#/usr/bin/perl
#Importation des modules: Unicode::String et XML::RSS
use Unicode::String qw(utf8);
use XML::RSS;
<<DOC; #introduit dans un fichier perl de la documentation intégree au programme
Votre Nom : DOUDANE Camille, OKININA NADIA et TUBIANA Séverine
JANVIER 2011
 usage : perl parcours-arborescence-fichiers repertoire-a-parcourir
 Le programme prend en entrée le nom du répertoire contenant les fichiers
 à traiter
 Le programme construit en sortie un fichier:
 - un fichier contenant le corpus  extrait des fils RSS (format texte)
 - un fichier contenant le corpus extrait des fils RSS (format XML)
 
DOC

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------
#on récupère le nom du répertoire tapé par l'utilisateur dans l'entrée standard
my $rep="$ARGV[0]"; 
#on s'assure que le nom du répertoire ne se termine pas par un "/"
$rep=~ s/[\/]$//; 

#on initialise trois variables pour créer des fichiers de sortie
my $DUMPXML=""; 
my $DUMPTXT="";

#on initialise une variable qui servira à traiter le numeroéro de la rubrique plus tard.
my $numero="";
#on initialise une variable qui servira à traiter le nom de la rubrique plus tard. 
my $rubrique="";
#on initialise une variable qui servira à traiter la date de l'article plus tard. 
my $date="";

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

# L'utilisateur entre son choix de rubrique dans l'entrée standard.  

print "Entrez l'identifiantentifiant de la rubrique a traiter ou * pour obtenir toutes les rubriques : \n";
print "0 : A la une\t\t\t\t8 : Medias\n
1 : International\t\t\t9 : Rendez-vous\n
2 : Europe\t\t\t\t10 : Sports\n
3 : Livres\t\t\t\t11 : Opinions\n
4 : Cinema\t\t\t\t12 : Planete\n
5 : Technologies\t\t\t13 : Voyages\n
6 : Politique\t\t\t\t14 : Culture\n
7 : Economie\t\t\t\t15 : Societe\n
ALL:* \n\n
Votre choix : ";

# on récupère dans une variable appelé $identifiant le choix de la rubrique de l'utilisateur tapé dans l'entrée standard.
$identifiant = <STDIN>;

# on supprime le dernier caractère de retour à la ligne, s'il y en a un.
chomp($identifiant);

#On fait une condition pour traiter le choix de la rubrique de l'utilisateur:

#Si la variable $identifiant est équivalent à 0
if ($identifiant eq 0){
	#Le numéro sera: 3208
	$numero="3208";
	#Le nom de la varaiable rubrique sera: a_la_une
	$rubrique="a_la_une";
	} 
#Sinon si la variable $identifiant est équivalent à	1
elsif ($identifiant eq 1){
	#Le numéro sera: 3210
	$numero="3210";
	#Le nom de la varaiable rubrique sera: international
	$rubrique="international";
	}
#Sinon si la variable $identifiant est équivalent à	2	
elsif ($identifiant eq 2){
	#Le numéro sera: 3214
	$numero="3214";
	#Le nom de la varaiable rubrique sera: europe
	$rubrique="europe";
	}
#Sinon si la variable $identifiant est équivalent à	3	
elsif ($identifiant eq 3){
	#Le numéro sera: 3260
	$numero="3260";
	#Le nom de la varaiable rubrique sera: livres
	$rubrique="livres";
	}
#Sinon si la variable $identifiant est équivalent à	4	
elsif ($identifiant eq 4){
	#Le numéro sera: 3476
	$numero="3476";
	#Le nom de la varaiable rubrique sera: cinema
	$rubrique="cinema";
	}
#Sinon si la variable $identifiant est équivalent à	5	
elsif ($identifiant eq 5){
	#Le numéro sera: 651865
	$numero="651865";
	#Le nom de la varaiable rubrique sera: technologie
	$rubrique="technologie";
	}
#Sinon si la variable $identifiant est équivalent à	6	
elsif ($identifiant eq 6){
	#Le numéro sera: 823353
	$numero="823353";
	#Le nom de la varaiable rubrique sera: politique
	$rubrique="politique";
	}
#Sinon si la variable $identifiant est équivalent à	7	
elsif ($identifiant eq 7){
	#Le numéro sera: 3234
	$numero="3234";
	#Le nom de la varaiable rubrique sera: economie
	$rubrique="economie";
	}
#Sinon si la variable $identifiant est équivalent à	8	
elsif ($identifiant eq 8){
	#Le numéro sera: 3236
	$numero="3236";
	#Le nom de la varaiable rubrique sera: medias
	$rubrique="medias";
	}
#Sinon si la variable $identifiant est équivalent à	9	
elsif ($identifiant eq 9){
	#Le numéro sera: 3238
	$numero="3238";
	#Le nom de la varaiable rubrique sera: rendez-vous
	$rubrique="rendez-vous";
	}
#Sinon si la variable $identifiant est équivalent à	10	
elsif ($identifiant eq 10){
	#Le numéro sera: 3242
	$numero="3242";
	#Le nom de la varaiable rubrique sera: sport
	$rubrique="sport";
	}
#Sinon si la variable $identifiant est équivalent à	11	
elsif ($identifiant eq 11){
	#Le numéro sera: 3232
	$numero="3232";
	#Le nom de la varaiable rubrique sera: opinions
	$rubrique="opinions";
	}
#Sinon si la variable $identifiant est équivalent à	12	
elsif ($identifiant eq 12){
	#Le numéro sera: 32344
	$numero="32344";
	#Le nom de la varaiable rubrique sera: planete
	$rubrique="planete";
	}
#Sinon si la variable $identifiant est équivalent à	13	
elsif ($identifiant eq 13){
	#Le numéro sera: 3246
	$numero="3246";
	#Le nom de la varaiable rubrique sera: voyages
	$rubrique="voyages";
	}
#Sinon si la variable $identifiant est équivalent à	14	
elsif ($identifiant eq 14){
	#Le numéro sera: 3546
	$numero="3546";
	#Le nom de la varaiable rubrique sera: culture
	$rubrique="culture";
	}
#Sinon si la variable $identifiant est équivalent à	15	
elsif ($identifiant eq 15){
	#Le numéro sera: 3224
	$numero="3224";
	#Le nom de la varaiable rubrique sera: societe
	$rubrique="societe";
	}
#Sinon si la variable $identifiant est équivalent à	16	
elsif ($identifiant eq "*"){
	#Le numéro sera toutes les rubriques
	$numero="ALL";
	#Le nom de la varaiable rubrique sera:
	$rubrique="toutes_les_rubriques";
	}
#Sinon on affiche dans l'entrée standard:		
else{ 
	print "Veuillez encore indiquer la rubrique a traiter\n"; 
	}  

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

#attribution des noms de sorties pour les formats xml et txt:
my $output1_xml="SORTIES_RSS_".$rubrique.".xml";
my $output2_txt="SORTIES_RSS_".$rubrique.".txt";


#création des fichiers xml et txt en utf-8
my $encodagesortie="utf-8";
if (!open(OUTXML,">:encoding($encodagesortie)",$output1_xml)) { die "Pb a l'ouverture du fichier $output1_xml.xml"};
if (!open(OUTTXT,">:encoding($encodagesortie)",$output2_txt)) { die "Pb a l'ouverture du fichier $output2_txt.txt"};

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

#on appelle le sous-programme
&parcoursarborescencefichiers($rep,$numero);

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

#Pour les fichiers de sorties en format XML:
#on crée les balises en début de fichier XML de sortie
print OUTXML "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n"; 
print OUTXML "<PARCOURS>\n";
print OUTXML "<NOM>DOUDANE, OKININA et TUBIANA</NOM>\n";
#le contenu du filtage contenu dans la variable $$DUMPXML sera intégré dans la balise <FILTRAGE>
print OUTXML "<FILTRAGE rubrique=\"".$rubrique."\" identifiant=\"$numero\">\n".$DUMPXML."</FILTRAGE>\n";
print OUTXML "</PARCOURS>\n";
close(OUTXML);

#Pour les fichiers de sorties en sortie TXT:
#on va remplir le fichier de sortie avec le contenu de DUMPTXT
print OUTTXT "$DUMPTXT";
close (OUTTXT);

# Fin du programme
exit;

#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

###########################################ON LANCE LES PROCEDURES: ####################################

#Procédure pour le parcours d'arborescence de fichiers:
sub parcoursarborescencefichiers { 
	#le tableau des arguments symbolisé par "@_" est stocké dans la variable $path et $num  
    my ($path,$numero) = @_; 
	#on ouvre le répertoire appelé par le nom DIR, sinon un messsage d'erreur s'affiche
    opendir(DIR, $path) or die "can't open $path: $!\n"; 
	#on stocke le contenu du répertoire dans le tableau @files
    my @files = readdir(DIR); 
	#on ferme le répertoire
    closedir(DIR);
    
	#pour chaque fichier ou répertoire présent dans le tableau @files on effctue les instructions suivantes:
    foreach my $file (@files) {
	#on veut ignorer les fichiers commençant par un .
	next if $file =~ /^\.\.?$/;
	#on écrase la variable $file pour la remplacer par $nomdefichier
	my $nomdefichier=$file;
	#on récupère le chemin d'accès complet au fichier
	$file = $path."/".$file; 
	
	
	#Savoir si la variable $file est un répertoire ou un fichier.
	# avec l'option -d on vérifie que file est un répertoire, il faut donc à nouveau fouiller ce répertoire
	if (-d $file) { 
		#on relance le sous programme sur $file
	    &parcoursarborescencefichiers($file,$numero);	
	    
	}
	# l'option -f vérifie que la variable file est un fichier
	if ((-f $file) && ($file=~/.xml$/) && ($nomdefichier!~/^fil/)) {
		#initialisation de la variable
		my $file2traite="";
		#traitement de tous le fichiers 
		if ($numero eq "ALL") { 
			$file2traite=$file;
		}
		else {
			#traitement d'une rubrique en particulier
			if ($file=~/0,2-$numero,1-0,0\.xml$/) {
				$file2traite=$file;
			}
		}
		if ($file2traite ne "") {
			#print "contenu de $file : \n"; #lecture de $file
			print "FILE : <$file> \n";
		    #lecture de $file
		    open(FILE, $file);
			#initialisation de la variable texte1
			my $texte1="";
			# boucle qui signifie qu'on lit chaque ligne du fichier
			while (my $ligne=<FILE>) {
				#je retire le retour à la ligne et on remplace par rien
				$ligne =~ s/\n//g;
				#on concatène ensuite toutes les lignes dans une variable nommée $texte1
				$texte1 .= $ligne;
			}
			#on ferme le fichier
		    close(FILE);	
			#variable permettant d'extraire le motif d'encodage
			$texte1=~/encoding ?= ?[\'\"]([^\'\"]+)[\'\"]/i;
			#Le résultat de la recherche précédente ($1) est stocké dans la variable $encodage
			my $encodage=$1;
			#on affiche l'encodage
			print "ENCODAGE : $encodage \n";			
			#ouverture du fichier en écriture
		    open(FILE,"<:encoding($encodage)", $file); 
			#iinitialisation de la variable $texte
		    my $texte=""; 
			#on crée l'objet xml:rss vide avec "new". La valeur de cet objet est stockée dans la variable $rss. 
			my $rss=new XML::RSS;
			#parsefile verifie si le fichier a été bien formé. 
			#eval permet d'évaluer le comportement d'une commande et de continuer quelque soit le résultat.
			eval {$rss->parsefile($file); }; 
			
		#si le resultat est mauvais, on signale qu'il y a une erreur. $@ contient le resultat de la commande qu' on évalue juste au-dessus.	
		if( $@ ) {   
		    $@ =~ s/at \/.*?$//s;              
		    print STDERR "\nERROR in '$file':\n$@\n";
		} 
		#sinon la commande est bonne
		else {  
		    $DUMPXML.="<file>\n";
			#on va à la variable $rss pour chercher en channel, la date de publication. Le résultat est stocké dans la variable $date.
		    my $date=$rss->{'channel'}->{'pubDate'}; 
			#je mets la variable date dans la balise date
		    $DUMPXML.="<date>".$date."</date>\n"; 
			#on met le texte dans la balise items
		    $DUMPXML.="<items>\n";
		    #on fait l'extraction du contenu textuel en utilisant la bibliothèque RSS
		    foreach my $item (@{$rss->{'items'}}) 
		    { 
			#il va chercher toute la liste des items
			my $titre=$item->{'title'};
			my $resume=$item->{'description'};
			#on suprime les scories que peuvent apparaitre dans le contenu textuel. Le resultat sera renvoyé à la variable $titre
			$titre=&nettoietexte($titre);
			#on suprime les scories que peuvent apparaitre dans le contenu textuel. Le resultat sera renvoyé à la variable $resume
			$resume=&nettoietexte($resume);
	
			#Si c'est pas de l'utf-8, je transforme la variable $tire et $resume en utf-8
			if (uc($encodage) ne "UTF-8") {utf8($titre);utf8($resume);}
			#on stocke tous les résultats du contenu textuel dans la variable $DUMPTXT et $DUMPXML
			$DUMPTXT.="Titre : $titre \n";
			$DUMPTXT.="Resume : $resume \n";;
			$DUMPXML.="<item><title>$titre</title><abstract>$resume</abstract></item>\n";
		    }
		    $DUMPXML.="</items>\n</file>\n";
			#on ferme le fichier
		    close(FILE);
		}
	}
    }
}
#--------------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------------

#Procédure pour nettoyer le texte:
#La procédure renvoie à la fin la variable $texte.

sub nettoietexte {
    my $texte=shift; #prend une entrée un parametre et revoie une valeur de la chaine de caracteres nettoyé.fonction shift je vide le tableau des arguments passé à la procédure
    #ce nettoyage est insuffisant
    $texte =~ s/&lt;/</g;
    $texte =~ s/&gt;/>/g;
    $texte =~ s/<a href[^>]+>//g;
    $texte =~ s/<img[^>]+>//g;
    $texte =~ s/<\/a>//g;
    $texte =~ s/&#38;#39;/'/g;
    $texte =~ s/&#38;#34;/"/g;
    $texte =~ s/<[^>]+>//g;
    $texte =~s/&#39;/\'/g;
    $texte =~s/&#34;/\"/g;
    $texte =~s/&#233;/é/g;
    $texte =~s/&#234;/ê/g;
    $texte =~s/&amp;eacute;/é/g;
    $texte =~s/&amp;egrave;/è/g;
    $texte =~s/&amp;icirc;/\î/g;
    $texte =~s/&amp;ocirc;/\ô/g;
    $texte =~s/&amp;ccedil;/\ç/g;
    $texte =~s/&amp;agrave;/\à/g;
    $texte =~s/&#38;/&/g;
    $texte =~s/<.*$//g;
	$texte =~ s/&amp;|&#38;/&/g;
	$texte =~ s/&amp;|&#38;/&/g; 
	$texte =~ s/&apos;|&#39;/'/g; 
	$texte =~ s/&nbsp;|&#160;/? /g; 
	$texte =~ s/&shy;|&#173;/­/g; 
	$texte =~ s/&quot;|&#34;/"/g; 
	$texte =~ s/&laquo;|&#171;/«/g; 
	$texte =~ s/&raquo;|&#187;/»/g; 
	$texte =~ s/&lsaquo;|&#8249;/‹/g; 
	$texte =~ s/&rsaquo;|&#8250;/›/g; 
	$texte =~ s/&ldquo;|&#8220;/“/g; 
	$texte =~ s/&rdquo;|&#8221;/”/g; 
	$texte =~ s/&bdquo;|&#8222;/„/g; 
	$texte =~ s/&lsquo;|&#8216;/‘/g; 
	$texte =~ s/&bdquo;|&#8222;/„/g; 
	$texte =~ s/&rsquo;|&#8217;/’/g; 
	$texte =~ s/&sbquo;|&#8218;/‚/g; 
	$texte =~ s/&hellip;|&#8230;/…/g; 
	$texte =~ s/!|&#33;/!/g; 
	$texte =~ s/&iexcl;|&#161;/¡/g; 
	$texte =~ s/\?|&#63;/\?/g;
	$texte =~ s/\(|&#40;/\(/g; 
	$texte =~ s/\)|&#41;/\)/g; 
	$texte =~ s/\[|&#91;/\[/g; 
	$texte =~ s/]|&#93;/]/g; 
	$texte =~ s/{|&#123;/{/g; 
	$texte =~ s/}|&#125;/}/g; 
	$texte =~ s/&uml;|&#168;/¨/g; 
	$texte =~ s/&acute;|&#180;/´/g; 
	$texte =~ s/`|&#96;/`/g; 
	$texte =~ s/\^|&#94;/\^/g; 
	$texte =~ s/&circ;|&#710;/ˆ/g; 
	$texte =~ s/~|&#126;/~/g; 
	$texte =~ s/#|&#35;/#/g; 
	$texte =~ s/\*|&#42;/\*/g; 
	$texte =~ s/,|&#44;/,/g; 
	$texte =~ s/\.|&#46;/\./g; 
	$texte =~ s/:|&#58;/:/g; 
	$texte =~ s/;|&#59;/;/g; 
	$texte =~ s/&middot;|&#183;/·/g; 
	$texte =~ s/&bull;|&#8226;/•/g; 
	$texte =~ s/&macr;|&#175;/¯/g; 
	$texte =~ s/-|&#45;/-/g; 
	$texte =~ s/&ndash;|&#8211;/–/g; 
	$texte =~ s/&mdash;|&#8212;/—/g; 
	$texte =~ s/_|&#95;/_/g; 
	$texte =~ s/\||&#124;/\|/g; 
	$texte =~ s/&brvbar;|&#166;/¦/g; 
	$texte =~ s/&zwj;|&#8205;/?/g; 
	$texte =~ s/&dagger;|&#8224;/†/g; 
	$texte =~ s/&Dagger;|&#8225;/‡/g; 
	$texte =~ s/&Dagger;|&#8225;/‡/g; 
	$texte =~ s/&sect;|&#167;/§/g;
	$texte =~ s/&para;|&#182;/¶/g;
	$texte =~ s/&copy;|&#169;/©/g;
	$texte =~ s/&reg;|&#174;/®/g;
	$texte =~ s/&trade;|&#8482;/™/g;
	$texte =~ s/@|&#64;/@/g;
	$texte =~ s/\/|&#47;/\//g;
	$texte =~ s/\\|&#92;/\\/g;
	$texte =~ s/&loz;|&#9674;/?/g;
	$texte =~ s/&spades;|&#9824;/?/g;
	$texte =~ s/&clubs;|&#9827;/?/g;
	$texte =~ s/&hearts;|&#9829;/?/g;
	$texte =~ s/&diams;|&#9830;/?/g;
	$texte =~ s/&larr;|&#8592;/?/g;
	$texte =~ s/&uarr;|&#8593;/?/g;
	$texte =~ s/&rarr;|&#8594;/?/g;
	$texte =~ s/&darr;|&#8595;/?/g;
	$texte =~ s/&harr;|&#8596;/?/g;
	$texte =~ s/&aacute;|&#225;/á/g;
	$texte =~ s/&Aacute;|&#193;/Á/g;
	$texte =~ s/&acirc;|&#226;/â/g;
	$texte =~ s/&Acirc;|&#194;/Â/g;
	$texte =~ s/&agrave;|&#224;/à/g;
	$texte =~ s/&Agrave;|&#192;/À/g;
	$texte =~ s/&aring;|&#229;/å/g;
	$texte =~ s/&Aring;|&#197;/Å/g;
	$texte =~ s/&atilde;|&#227;/ã/g;
	$texte =~ s/&Atilde;|&#195;/Ã/g;
	$texte =~ s/&auml;|&#228;/ä/g;
	$texte =~ s/&Auml;|&#196;/Ä/g;
	$texte =~ s/&aelig;|&#230;/æ/g;
	$texte =~ s/&AElig;|&#198;/Æ/g;
	$texte =~ s/&ccedil;|&#231;/ç/g;
	$texte =~ s/&Ccedil;|&#199;/Ç/g;
	$texte =~ s/&eacute;|&#233;/é/g;
	$texte =~ s/&Eacute;|&#201;/É/g;
	$texte =~ s/&ecirc;|&#234;/ê/g;
	$texte =~ s/&Ecirc;|&#202;/Ê/g;
	$texte =~ s/&egrave;|&#232;/è/g;
	$texte =~ s/&Egrave;|&#200;/È/g;
	$texte =~ s/&euml;|&#235;/ë/g;
	$texte =~ s/&Euml;|&#203;/Ë/g;
	$texte =~ s/&iacute;|&#237;/í/g;
	$texte =~ s/&Iacute;|&#205;/Í/g;
	$texte =~ s/&icirc;|&#238;/î/g;
	$texte =~ s/&Icirc;|&#206;/Î/g;
	$texte =~ s/&igrave;|&#236;/ì/g;
	$texte =~ s/&Igrave;|&#204;/Ì/g;
	$texte =~ s/&iuml;|&#239;/ï/g;
	$texte =~ s/&Iuml;|&#207;/Ï/g;
	$texte =~ s/&ntilde;|&#241;/ñ/g;
	$texte =~ s/&Ntilde;|&#209;/Ñ/g;
	$texte =~ s/&oacute;|&#243;/ó/g;
	$texte =~ s/&Oacute;|&#211;/Ó/g;
	$texte =~ s/&ocirc;|&#244;/ô/g;
	$texte =~ s/&Ocirc;|&#212;/Ô/g;
	$texte =~ s/&ograve;|&#242;/ò/g;
	$texte =~ s/&Ograve;|&#210;/Ò/g;
	$texte =~ s/&oslash;|&#248;/ø/g;
	$texte =~ s/&Oslash;|&#216;/Ø/g;
	$texte =~ s/&otilde;|&#245;/õ/g;
	$texte =~ s/&Otilde;|&#213;/Õ/g;
	$texte =~ s/&ouml;|&#246;/ö/g;
	$texte =~ s/&Ouml;|&#214;/Ö/g;
	$texte =~ s/&oelig;|&#156;/œ/g;
	$texte =~ s/&OElig;|&#140;/Œ/g;
	$texte =~ s/&scaron;|&#353;/š/g;
	$texte =~ s/&Scaron;|&#352;/Š/g;
	$texte =~ s/&szlig;|&#223;/ß/g;
	$texte =~ s/&eth;|&#240;/ð/g;
	$texte =~ s/&ETH;|&#208;/Ð/g;
	$texte =~ s/&thorn;|&#254;/þ/g;
	$texte =~ s/&THORN;|&#222;/Þ/g;
	$texte =~ s/&uacute;|&#250;/ú/g;
	$texte =~ s/&Uacute;|&#218;/Ú/g;
	$texte =~ s/&ucirc;|&#251;/û/g;
	$texte =~ s/&Ucirc;|&#219;/Û/g;
	$texte =~ s/&ugrave;|&#249;/ù/g;
	$texte =~ s/&Ugrave;|&#217;/Ù/g;
	$texte =~ s/&uuml;|&#252;/ü/g;
	$texte =~ s/&Uuml;|&#220;/Ü/g;
	$texte =~ s/&yacute;|&#253;/ý/g;
	$texte =~ s/&Yacute;|&#221;/Ý/g;
	$texte =~ s/&yuml;|&#255;/ÿ/g;
	$texte =~ s/&Yuml;|&#376;/Ÿ/g;
	$texte =~ s/&curren;|&#164;/¤/g;
	$texte =~ s/&euro;|&#128;/€/g;
	$texte =~ s/\$|&#36;/\$/g;
	$texte =~ s/&cent;|&#162;/¢/g;
	$texte =~ s/&pound;|&#163;/£/g;
	$texte =~ s/&yen;|&#165;/¥/g;
	$texte =~ s/&fnof;|&#402;/ƒ/g;
	$texte =~ s/&alpha;|&#945;/a/g;
	$texte =~ s/&Alpha;|&#913;/?/g;
	$texte =~ s/&beta;|&#946;/ß/g;
	$texte =~ s/&Beta;|&#914;/?/g;
	$texte =~ s/&gamma;|&#947;/?/g;
	$texte =~ s/&Gamma;|&#915;/G/g;
	$texte =~ s/&delta;|&#948;/d/g;
	$texte =~ s/&Delta;|&#916;/?/g;
	$texte =~ s/&epsilon;|&#949;/e/g;
	$texte =~ s/&Epsilon;|&#917;/?/g;
	$texte =~ s/&zeta;|&#950;/?/g;
	$texte =~ s/&Zeta;|&#918;/?/g;
	$texte =~ s/&eta;|&#951;/?/g;
	$texte =~ s/&Eta;|&#919;/?/g;
	$texte =~ s/&theta;|&#952;/?/g;
	$texte =~ s/&Theta;|&#920;/T/g;
	$texte =~ s/&iota;|&#953;/?/g;
	$texte =~ s/&Iota;|&#921;/?/g;
	$texte =~ s/&kappa;|&#954;/?/g;
	$texte =~ s/&Kappa;|&#922;/?/g;
	$texte =~ s/&lambda;|&#955;/?/g;
	$texte =~ s/&Lambda;|&#923;/?/g;
	$texte =~ s/&mu;|&#956;/µ/g;
	$texte =~ s/&Mu;|&#924;/?/g;
	$texte =~ s/&nu;|&#957;/?/g;
	$texte =~ s/&Nu;|&#925;/?/g;
	$texte =~ s/&xi;|&#958;/?/g;
	$texte =~ s/&Xi;|&#926;/?/g;
	$texte =~ s/&omicron;|&#959;/?/g;
	$texte =~ s/&Omicron;|&#927;/?/g;
	$texte =~ s/&pi;|&#960;/p/g;
	$texte =~ s/&Pi;|&#928;/?/g;
	$texte =~ s/&rho;|&#961;/?/g;
	$texte =~ s/&Rho;|&#929;/?/g;
	$texte =~ s/&sigma;|&#963;/s/g;
	$texte =~ s/&sigmaf;|&#962;/?/g;
	$texte =~ s/&Sigma;|&#931;/S/g;
	$texte =~ s/&tau;|&#964;/t/g;
	$texte =~ s/&Tau;|&#932;/?/g;
	$texte =~ s/&upsilon;|&#965;/?/g;
	$texte =~ s/&Upsilon;|&#933;/?/g;
	$texte =~ s/&phi;|&#966;/f/g;
	$texte =~ s/&Phi;|&#934;/F/g;
	$texte =~ s/&chi;|&#967;/?/g;
	$texte =~ s/&Chi;|&#935;/?/g;
	$texte =~ s/&psi;|&#968;/?/g;
	$texte =~ s/&Psi;|&#936;/?/g;
	$texte =~ s/&omega;|&#969;/?/g;
	$texte =~ s/&Omega;|&#937;/O/g;
	$texte  =~ s/&deg;|&#176;/°/g;
	$texte =~ s/&micro;|&#181;/µ/g;
	$texte =~ s/&lt;|&#60;/</g;
	$texte =~ s/&gt;|&#62;/>/g;
	$texte =~ s/&le;|&#8804;/=/g;
	$texte =~ s/&ge;|&#8805;/=/g;
	$texte =~ s/=|&#61;/=/g;
	$texte =~ s/&asymp;|&#8776;/˜/g;
	$texte =~ s/&ne;|&#8800;/?/g;
	$texte =~ s/&equiv;|&#8801;/=/g;
	$texte =~ s/&plusmn;|&#177;/±/g;
	$texte =~ s/&minus;|&#8722;/-/g;
	$texte =~ s/\+|&#43;/\+/g;
	$texte =~ s/&times;|&#215;/×/g;
	$texte =~ s/&divide;|&#247;/÷/g;
	$texte =~ s/&frasl;|&#8260;//g;
	$texte =~ s/%|&#37;/%/g;
	$texte =~ s/&permil;|&#8240;/‰/g;
	$texte =~ s/&frac14;|&#188;/¼/g;
	$texte =~ s/&frac12;|&#188;/½/g;
	$texte =~ s/&frac34;|&#188;/¾/g;
	$texte =~ s/&sup1;|&#185;/¹/g;
	$texte =~ s/&sup2;|&#178;/²/g;
	$texte =~ s/&sup3;|&#179;/³/g;
	$texte =~ s/&ordm;|&#186;/º/g;
	$texte =~ s/&ordf;|&#170;/ª/g;
	$texte =~ s/&fnof;|&#402;/ƒ/g;
	$texte =~ s/&prime;|&#8242;/'/g;
	$texte =~ s/&Prime;|&#8243;/?/g;
	$texte =~ s/&part;|&#8706;/?/g;
	$texte =~ s/&prod;|&#8719;/?/g;
	$texte =~ s/&sum;|&#8721;/?/g;
	$texte =~ s/&radic;|&#8730;/v/g;
	$texte =~ s/&infin;|&#8734;/8/g;
	$texte =~ s/&not;|&#172;/¬/g;
	$texte =~ s/&cap;|&#8745;/n/g;
	$texte =~ s/&int;|&#8747;/?/g;
	$texte =~ s/<.+?>//g;
    return $texte;
	
	
}

